static ::mlir::LogicalResult CastOpInterfacePDLFn(::mlir::PatternRewriter &rewriter, ::mlir::Operation * self) {
  return ::mlir::success(llvm::isa<::mlir::CastOpInterface>(self));
}

namespace {

struct TestSimplePattern : ::mlir::PDLPatternModule {
  TestSimplePattern(::mlir::MLIRContext *context)
    : ::mlir::PDLPatternModule(::mlir::parseSourceString<::mlir::ModuleOp>(
R"mlir(pdl.pattern @TestSimplePattern : benefit(0) {
  %0 = operands loc("/usr/src/RPM/BUILD/llvm-project/mlir/test/lib/Tools/PDLL/TestPDLL.pdll":13:38)
  %1 = types loc("/usr/src/RPM/BUILD/llvm-project/mlir/test/lib/Tools/PDLL/TestPDLL.pdll":13:38)
  %2 = operation "test.simple"(%0 : !pdl.range<value>)  -> (%1 : !pdl.range<type>) loc("/usr/src/RPM/BUILD/llvm-project/mlir/test/lib/Tools/PDLL/TestPDLL.pdll":13:38)
  rewrite %2 {
    %3 = operation "test.success"  loc("/usr/src/RPM/BUILD/llvm-project/mlir/test/lib/Tools/PDLL/TestPDLL.pdll":13:59)
    replace %2 with %3 loc("/usr/src/RPM/BUILD/llvm-project/mlir/test/lib/Tools/PDLL/TestPDLL.pdll":13:30)
  } loc("/usr/src/RPM/BUILD/llvm-project/mlir/test/lib/Tools/PDLL/TestPDLL.pdll":13:30)
} loc("/usr/src/RPM/BUILD/llvm-project/mlir/test/lib/Tools/PDLL/TestPDLL.pdll":13:1)
    )mlir", context)) {
  }
};


struct TestInterface : ::mlir::PDLPatternModule {
  TestInterface(::mlir::MLIRContext *context)
    : ::mlir::PDLPatternModule(::mlir::parseSourceString<::mlir::ModuleOp>(
R"mlir(pdl.pattern @TestInterface : benefit(0) {
  %0 = operands loc("/usr/src/RPM/BUILD/llvm-project/mlir/test/lib/Tools/PDLL/TestPDLL.pdll":16:34)
  %1 = types loc("/usr/src/RPM/BUILD/llvm-project/mlir/test/lib/Tools/PDLL/TestPDLL.pdll":16:34)
  %2 = operation(%0 : !pdl.range<value>)  -> (%1 : !pdl.range<type>) loc("/usr/src/RPM/BUILD/llvm-project/mlir/test/lib/Tools/PDLL/TestPDLL.pdll":16:34)
  apply_native_constraint "CastOpInterface"(%2 : !pdl.operation) loc("/usr/src/RPM/BUILD/llvm-project/mlir/test/lib/Tools/PDLL/TestPDLL.pdll":16:37)
  rewrite %2 {
    %3 = operation "test.success"  loc("/usr/src/RPM/BUILD/llvm-project/mlir/test/lib/Tools/PDLL/TestPDLL.pdll":16:58)
    replace %2 with %3 loc("/usr/src/RPM/BUILD/llvm-project/mlir/test/lib/Tools/PDLL/TestPDLL.pdll":16:26)
  } loc("/usr/src/RPM/BUILD/llvm-project/mlir/test/lib/Tools/PDLL/TestPDLL.pdll":16:26)
} loc("/usr/src/RPM/BUILD/llvm-project/mlir/test/lib/Tools/PDLL/TestPDLL.pdll":16:1)
    )mlir", context)) {
    registerConstraintFunction("CastOpInterface", CastOpInterfacePDLFn);
  }
};

} // end namespace

static void LLVM_ATTRIBUTE_UNUSED populateGeneratedPDLLPatterns(::mlir::RewritePatternSet &patterns) {
  patterns.add<TestSimplePattern>(patterns.getContext());
  patterns.add<TestInterface>(patterns.getContext());
}
